<template>
  <component
    :is="tag"
    class="i-curtain d-flex flex-column justify-content-between"
    :class="{
      'i-curtain--scrollable': scrollable,
      'i-curtain--rounded': rounded && !fixed,
      'i-curtain--fixed': fixed,
      'i-curtain--bottom-fixed': bottomFixed,
      'i-curtain--full-height': fullHeight,
    }"
    :style="{ height: height ? `calc(${height}px * var(--scale))` : null, flex: flex }"
    @submit.prevent="$emit('submit')">
    <div v-if="fixed" class="i-curtain__corner-wrapper">
      <div class="i-curtain__corner-content">
        <div class="i-curtain__corner i-curtain__corner--left" />
        <div class="i-curtain__corner i-curtain__corner--right" />
      </div>
    </div>
    <div v-if="$slots.default" class="i-curtain__content d-flex flex-column align-items-center">
      <slot />
    </div>
    <div v-if="$slots.bottom" ref="bottom" class="i-curtain__bottom">
      <div ref="bottomWrapper" class="i-curtain__bottom-wrapper">
        <div ref="bottomContent" class="i-curtain__bottom-content">
          <slot name="bottom"></slot>
        </div>
      </div>
    </div>
    <img v-if="bottomCircles" src="~assets/images/circles-orange.svg" class="circles circles--bottomBack" />
  </component>
</template>

<script>
  export default {
    props: {
      tag: {
        type: String,
        default: 'div',
      },

      scrollable: Boolean,
      fixed: Boolean,
      bottomFixed: Boolean,

      bottomCircles: {
        type: Boolean,
        default: true,
      },

      rounded: {
        type: Boolean,
        default: true,
      },

      height: {
        type: Number,
        default: null,
      },

      flex: {
        type: Number,
        default: 1,
      },

      fullHeight: Boolean,
    },

    mounted() {
      if (this.bottomFixed) {
        this.$nextTick(() => {
          this.$refs.bottom.style.height = `${this.$refs.bottomWrapper.clientHeight}px`;
        });
      }
    },
  };
</script>

<style lang="scss">
  .i-curtain {
    position: relative;
    // padding-bottom: rs(20px);
    background-color: #fff;
    min-height: 100%;
    width: 100%;
    flex: 1;

    &--rounded {
      border-top-left-radius: rs(20px);
      border-top-right-radius: rs(20px);
    }
  }

  .i-curtain__corner-wrapper {
    position: fixed;
    z-index: 999;
    top: rs(44);
    left: 0;
    right: 0;
    display: flex;
    align-items: flex-start;
    justify-content: center;
    height: rs(20px);
    overflow: hidden;
    pointer-events: none;
  }

  .i-curtain__corner-content {
    position: relative;
    display: flex;
    width: 100%;
    max-width: 480px;
    height: rs(20px);
    align-items: center;
    justify-content: space-between;
  }

  .i-curtain__corner {
    position: absolute;
    z-index: 1;
    top: 0;
    width: rs(20px);
    height: rs(20px);
    background-color: transparent;
    overflow: hidden;

    &--left {
      left: 0;
    }

    &--right {
      right: 0;
    }

    &::before {
      position: absolute;
      z-index: 0;
      top: 0;
      display: block;
      content: '';
      width: rs(40px);
      height: rs(40px);
      border-radius: rs(20px);
      background-color: transparent;
    }

    &--left::before {
      left: 0;
      box-shadow: 0 0 0 5000px #fa8b6b;
    }

    &--right::before {
      right: 0;
      box-shadow: 0 0 0 5000px #feaf60;
    }
  }

  .i-curtain__content {
    position: relative;
    z-index: 1;
  }

  .i-curtain--scrollable .i-curtain__content {
    overflow-y: auto;
    height: 100%;
  }

  .i-curtain--full-height .i-curtain__content {
    flex: 1 1 auto;
  }

  .i-curtain__bottom-wrapper {
    position: fixed;
    z-index: 999;
    bottom: 0;
    left: 0;
    right: 0;
    display: flex;
    align-items: flex-start;
    justify-content: center;
  }

  .i-curtain:not(.i-curtain--bottom-fixed) .i-curtain__bottom-wrapper {
    position: relative;
  }

  .i-curtain__bottom-content {
    position: relative;
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: space-between;
    width: 100%;
    max-width: 480px;
    padding: rs(20px) rs(15px) rs(20px);
    // background-color: rgba(#fff, 50%);
    backdrop-filter: blur(rs(5px));
    box-shadow: 0 -4px 15px rgba(#000, 15%);
  }

  .i-curtain:not(.i-curtain--bottom-fixed) .i-curtain__bottom-content {
    backdrop-filter: none;
    box-shadow: none;
  }
</style>
